//  replacement MENU TO prompt system for use with SCRNSVR.PRG
//  screen saver program and the My_Inkey() function
//  these functions are used to replace the standard Clipper Prompt/Menu
//  system 
//  The following #COMMAND statements should be used as
//  replacements for standard MENU TO Command either at the 
//  top of each PRG file using the MENU TO command or saved in a header file
//  which should be declared as an #INCLUDE statement at the start
//  of each PRG file using the MENU TO command
//  A copy of the standard STD.CH file could be made
//  and these statements used to replace the original Clipper commands
//  IN THE COPY OF STD.CH
//  and the complier option to use a different header STD.CH file selected

//  #command @ <row>, <col> PROMPT <prompt> [MESSAGE <msg>]     ;
//      => M_Prmpt(<row>, <col>, <prompt> , <msg>, PrmtList )

//  #command MENU TO <v>                                         ;
//      => <v> := M_MenuTo( {|_1| if(PCount() == 0, <v>, <v> := _1)}, #<v> , PrmtList)

//  NOTE:-The variable PrmtList should be declared as a LOCAL ARRAY
//  variable of zero length in each function or procedure 
//  using the MENU TO command because these replacement functions use
//  it by passing it by reference
//  after the MENU TO command PrmtList should be reset with PrmtList:={}

#include "inkey.ch"
#include "set.ch"

**************************
FUNCTION M_Prmpt(Rw, Cl, Prmt , Msg , PrmtList)
**************************
/*+ function to use as alternate to standard prompt so screen saver
    can be used for the standard prompt command*/

local I


PrmtList:=if( valtype(PrmtList) !="A",{},PrmtList)

I:=Cl+len(Prmt)-1
aadd(PrmtList,{Rw,Cl,Rw,I,Prmt,Msg})
__AtPrompt( Rw, Cl, Prmt , Msg )
RETURN nil
  
//screen saver replacement menu to command
**************************
FUNCTION M_MenuTo( Blk,v,PrmtList)
**************************


local vX,I,J,K,L,M,R[4],nKey
local Sc,Ps,iPrmt[0]

//get the hightlight color
Sc:=setcolor()
L:=len(Sc)
Sc:=right(Sc,L-at(",",Sc))
Sc:=left(Sc,at(",",Sc)-1)

J:=len(PrmtList)

  //set up array of first letters of each prompt
  for I:=1 to J
    aadd(iPrmt,upper(left(alltrim(PrmtList[I,5]),1)))
  next
  K:=.f.
  nKey:=0
  @ PrmtList[1,1],PrmtList[1,2] say PrmtList[1,5] color Sc
  Ps:=1
  do while ! K
    //check the set message condition and display any message
    I:=set(_SET_MESSAGE)
    if I>0
      @ I,0 clear to I,maxcol()
      if valtype(PrmtList[Ps,6])=="B"
        eval(PrmtList[Ps,6])
      else
        if set(_SET_MCENTER)
          Centrtxt(I,PrmtList[Ps,6])
        else
          @ I,1 say PrmtList[Ps,6]
        endif
      endif
    endif
    //catch any keyboard input
    nKey:=My_inkey()
    if nKey==K_ESC
      vX:=0
      K:=.t.
    elseif nKey==K_DOWN .or. nKey==K_RIGHT
      @ PrmtList[Ps,1],PrmtList[Ps,2] say PrmtList[Ps,5]
      Ps:=if(Ps==J,1,Ps+1)
      @ PrmtList[Ps,1],PrmtList[Ps,2] say PrmtList[Ps,5] color Sc
    elseif nKey==K_HOME
      @ PrmtList[Ps,1],PrmtList[Ps,2] say PrmtList[Ps,5]
      Ps:=1
      @ PrmtList[Ps,1],PrmtList[Ps,2] say PrmtList[Ps,5] color Sc
    elseif nKey==K_END
      @ PrmtList[Ps,1],PrmtList[Ps,2] say PrmtList[Ps,5]
      Ps:=J
      @ PrmtList[Ps,1],PrmtList[Ps,2] say PrmtList[Ps,5] color Sc
    elseif nKey=K_UP .or. nKey==K_LEFT
      @ PrmtList[Ps,1],PrmtList[Ps,2] say PrmtList[Ps,5]
      Ps:=if(Ps==1,J,Ps-1)
      @ PrmtList[Ps,1],PrmtList[Ps,2] say PrmtList[Ps,5] color Sc
    elseif nKey==K_ENTER .or. nKey==K_PGUP .or. nKey==K_PGDN
      vX:=Ps
      K:=.t.
    else
      M:=ascan(iPrmt,{|X| asc(X)==nKey})
      if M>0
        vX:=M
        K:=.t.
      endif
    endif
  enddo

RETURN vX


***********************************
FUNCTION Prmt_Clr1(Msg,Rw,Cent,C_str)
***********************************
/*+ function to display prompt msg in different color ar Rw
    Cent=.T. if msg to be centered
    C_str is color to display in*/

local C
@ Rw,0 clear to Rw,maxcol()
if Cent==.T.
  Centrtxt(Rw,Msg,C_Str)
else
  @ Rw,1 say Msg color C_Str
endif
return nil

